/*
 *			    Squirt BlueTooth Obex common
 *			    ----------------------------
 *
 *		Jean II '00
 *
 * Public header for squirt_bt_obex.c
 * Defines all you need to know about the "library" ;-)
 *
 * This file is released under the GPL license.
 */

/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#ifndef SQUIRT_OBEX_BT_H
#define SQUIRT_OBEX_BT_H

/***************************** INCLUDES *****************************/

#include "squirt_common.h"

/**************************** PROTOTYPES ****************************/

/* Send a squirt over Obex */
extern int
	send_bt_obex(es_squirt *	content,	/* Payload */
		     es_opt *		options,	/* How to process */
		     es_trans *		extra,		/* Optional data */
		     gi_obget *		reply,		/* Optional Rx hdrs */
		     gi_flags *		flags);		/* Optional Rx flags */
/* Add a squirt listener over Obex */
extern es_listen *
	add_bt_obex(es_listen *	list,
		    es_opt *	options);
/* Send a squirt over Obex GET */
extern int
	send_bt_obex_get(es_squirt *	squirt,		/* Optional squirt */
			 es_opt *	options,	/* For the squirt */
			 es_trans *	extra,		/* Transport data */
			 gi_obget *	request,	/* What to get */
			 gi_flags *	flags);		/* How to get it */
/* Issue a get-interface command over Obex */
extern int
	get_interface_bt_obex(gi_obget *	request,/* What to get */
			      gi_flags *	flags,	/* How to get it */
			      es_trans *	extra);	/* Transport data */
#endif	/* SQUIRT_OBEX_BT_H */
