/*
 *			    Get Interface
 *			    -------------
 *
 *		Jean II '00
 *
 * Get the interface of the other node.
 * The other node must run an e-Squirt app with the get interface handler set,
 * such as squirt.c...
 *
 * This file is released under the GPL license.
 */

/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <squirt.h>

/*#define BROWSER		"lynx %s"*/
//#define BROWSER		"netscape %s &"

/******************************* MAIN *******************************/

/* ---------------------------------------------------------------- */
/*
 * main body of the program
 */
int
main(int	argc,
     char *	argv[])
{
  gi_obget	interface;
  gi_flags	flags;
  es_trans	extra;
  int		ret = -1;

  init_structs(NULL, NULL, &extra, &interface, &flags, NULL);

  /* Look if there is any command line args */
  switch(argc)
    {
    case 0:
      /* Fallthrough */
    case 1:
      /* First arg is the link address, so we need it */
      fprintf(stderr, "Error, need link address + args\n");
      return(-1);
    case 2:
      /* No argument : no name or type */
      break;
    case 3:
      /* One argument : the filename */
      strcpy(extra.filename, argv[2]);
      flags.obex.name = OPT_OBEX_HAS_NAME;
      break;
    default:
      /* Fallthrough */
    case 4:
      /* Two arguments : filename + type */
      strcpy(extra.filename, argv[2]);
      flags.obex.name = OPT_OBEX_HAS_NAME;
      strcpy(extra.accept, argv[3]);
      flags.obex.accept = OPT_OBEX_HAS_ACCEPT;
      break;
    }

  /* Set link address */
  strcpy(extra.linkaddr, argv[1]);
  flags.linkaddr = OPT_DO_LINKADDR;

  /* Get the interface */
  ret = get_interface(&interface, &flags, &extra);

  /* Display it */
  debug_obget(&interface, &flags, &extra);

  /* Cleanup */
  free_structs(NULL, &extra, &interface);

  /* Check */
  if(ret < 0)
    printf("Get interface failed...\n");

  return(ret);
}
