/*
 *			    IrDA Obex Squirt
 *			    ----------------
 *
 *		Jean II '99 & '00
 *
 * Send and receive e-Squirt using Obex.
 *
 * This file is released under the GPL license.
 */

/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <squirt.h>

/*#define BROWSER		"lynx %s"*/
//#define BROWSER		"netscape %s &"

/******************************* MAIN *******************************/

/* ---------------------------------------------------------------- */
/*
 * main body of the program
 */
int
main(int	argc,
     char *	argv[])
{
  es_squirt	fields;
  es_opt	options;
  int		ret = -1;

  init_structs(&fields, &options, NULL, NULL, NULL, NULL);
  /* Set the options */
  options.xml = OPT_XML_STD;
  options.model = OPT_UNDEFINED;	/* Only for the receiver */
  options.transport = OPT_IRDA;
  options.protocol = OPT_OBEX;
  options.obex.type = OPT_OBEX_TYPE_NONE;
  options.obex.session = OPT_OBEX_NO_SESSION;
  options.obex.target = OPT_OBEX_TARGET_ASCII;

  /* Look if there is any command line args */
  switch(argc)
    {
    case 0:
      /* Fallthrough */
    case 1:
      /* No argument : receive a beacon */
      break;
    case 2:
      /* One argument : the URL */
      strcpy(fields.url, argv[1]);
      break;
    case 3:
      /* Two arguments : label + url */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      break;
    default:
      /* Fallthrough */
    case 4:
      /* Three arguments : label + url + type */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      strcpy(fields.type, argv[3]);
      break;
    }

  if(argc > 1)
    {
      /* Send a single e-Squirt/Beacon */
      options.model = OPT_BEACON;	/* Make sure model is defined */
      ret = send_squirt(&fields, &options, NULL, NULL, NULL);
      if(ret < 0)
	printf("Sending e-Squirt failed...\n");
    }
  else
    {
      /* Receive multiple e-Squirt/Beacon */
      printf("Waiting for e-Squirts over Obex...\n");
      while(1)
	{
	  /* Get one */
	  recv_squirt(&fields, &options, NULL, NULL, NULL);

	  debug_squirt(&fields, &options, NULL);
#ifdef BROWSER
	  {
	    unsigned char		buf[512];	/* The command */
	    sprintf(buf, BROWSER, fields->url);
	    system(buf);
	  }
#endif
	  /* Cleanup */
	  free_structs(&fields, NULL, NULL);
	}
      /* Will loop forever */
    }

  return(ret);
}
