/*
 *			    Generic Squirt
 *			    --------------
 *
 *		Jean II '99 & '00
 *
 * Remote control netscape.
 * Performance just s***. We should get the netscape-remote code
 * *in here* to avoid abusing system.
 * For more, please see :
 *	http://home.netscape.com/newsref/std/x-remote.html
 *
 * This file is released under the GPL license.
 */

/*
Copyright (C) 1995-2001 Hewlett-Packard Company 

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/

#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include <squirt.h>

#define BROWSER		"netscape -remote '%s'"
//#define BROWSER		"mozilla -remote '%s'"
//#define BROWSER		"~/mozilla/netscape-remote -remote '%s'"

typedef struct command_binding
{
  char *	es_name;
  char *	ns_name;
  int		repeat;
} command_binding;

#define OPENURL		"openURL(%s)"
const command_binding	commands[] =
{
  { "cmd:up",		"PageUp()",		1 },
  { "cmd:down",		"PageDown()",		1 },
  { "cmd:lup",		"LineUp()",		1 },
  { "cmd:ldown",	"LineDown()",		1 },
  { "cmd:6up",		"LineUp()",		6 },
  { "cmd:6down",	"LineDown()",		6 },
  { "cmd:back",		"back()",		1 },
  { "cmd:forward",	"forward()",		1 },
  { "cmd:left",		"ColumnLeft()",		1 },
  { "cmd:right",	"ColumnRight()",	1 },
  { "cmd:6left",	"ColumnLeft()",		6 },
  { "cmd:6right",	"ColumnRight()",	6 },
};
#define NUM_COMMANDS	(sizeof(commands)/sizeof(command_binding))

/***************************** RECEIVER *****************************/

/* ---------------------------------------------------------------- */
/*
 * Receive a e-Squirt of Beacon.
 */
int
receive_esquirt(es_squirt *	fields,		/* Rx payload */
		es_opt *	options,	/* Rx options */
		es_trans *	extra,		/* Rx transport data */
		gi_obget *	ret_hdr,	/* Return filename */
		gi_flags *	ret_flags)	/* Return flags */
{
  int		ret = 0;	/* Reply Header not set */
  unsigned char	bufn[550];	/* The netscape command */
  unsigned char	bufs[575];	/* The system command */
  int		repeat = 1;
  int		i;

  /* Display content */
  debug_squirt(fields, options, extra);

  /* By default, open the URL */
  sprintf(bufn, OPENURL, fields->url);
  /* Check if it's one of the known command */
  for(i = 0; i < NUM_COMMANDS; i++)
    if(!strcmp(fields->url, commands[i].es_name))
      {
	strcpy(bufn, commands[i].ns_name);
	repeat = commands[i].repeat;
	break;
      }
  /* Just do it */
  sprintf(bufs, BROWSER, bufn);
  printf("Running command [%s]\n", bufs);
  for(i = 0; i < repeat; i++)
    system(bufs);

  /* Check if we can return some data
   * We could also check if it is OPT_OBEX or OPT_OBEX_GET */
  if(ret_hdr != (gi_obget *) NULL)
    {
      /* Set the name */
      strcpy(extra->filename, "index.html");
      ret_flags->obex.name = OPT_OBEX_HAS_NAME;
      /* Set the types we support (only applicable for OPT_OBEX) */
      strcpy(extra->accept, "text/html, text/xml");
      ret_flags->obex.accept = OPT_OBEX_HAS_ACCEPT;

      ret = 1;	/* Reply Header set */
    }

  /* Return back to the server */
  return(ret);
}

/******************************* MAIN *******************************/

/* ---------------------------------------------------------------- */
/*
 * main body of the program
 */
int
main(int	argc,
     char *	argv[])
{
  es_squirt	fields;
  es_opt	options;
  es_trans	extra;
  gi_obget	ret_hdr;
  gi_flags	ret_flags;
  int		ret = -1;

  init_structs(&fields, &options, &extra, &ret_hdr, &ret_flags, NULL);
  /* Set the options */
  options.xml = OPT_XML_STD;
  options.model = OPT_UNDEFINED;	/* Only for the receiver */
  options.transport = OPT_UNDEFINED;
  options.protocol = OPT_UNDEFINED;
  options.obex.type = OPT_UNDEFINED;	/* auto */
  options.get_iface = OPT_NO_GIFACE;
  options.uobex_dups = OPT_UOS_DUPS_DEL;

  /* Look if there is any command line args */
  switch(argc)
    {
    case 0:
      /* Fallthrough */
    case 1:
      /* No argument : receive a beacon */
      break;
    case 2:
      /* One argument : the URL */
      strcpy(fields.url, argv[1]);
      break;
    case 3:
      /* Two arguments : label + url */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      break;
    default:
      /* Fallthrough */
    case 4:
      /* Three arguments : label + url + type */
      strcpy(fields.label, argv[1]);
      strcpy(fields.url, argv[2]);
      strcpy(fields.type, argv[3]);
      break;
    }

  if(argc > 1)
    {
      /* Send a single e-Squirt/Beacon */
      options.model = OPT_SQUIRT;	/* Make sure model is defined */
      ret = send_squirt(&fields, &options, &extra, &ret_hdr, &ret_flags);
      if(ret < 0)
	printf("Sending e-Squirt failed...\n");
      else
	if(ret > 0)
	  {
	    /* Check what we have */
	    debug_obget(&ret_hdr, &ret_flags, &extra);
	    /* Cleanup */
	    free_structs(NULL, &extra, &ret_hdr);
	  }
    }
  else
    {
      /* Receive multiple e-Squirt/Beacon */
      printf("Waiting for e-Squirts over all transports...\n");
      recv_squirt(&fields, &options, &extra, &receive_esquirt, NULL);
      /* Will loop forever */
    }

  return(ret);
}
